package sun.java2d.loops;

import sun.java2d.SurfaceData;
import sun.java2d.SunGraphics2D;

public class DrawParallelogram extends GraphicsPrimitive
{
    public static final String methodSignature;
    public static final int primTypeID;
    
    public static DrawParallelogram locate(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        return (DrawParallelogram)GraphicsPrimitiveMgr.locate(DrawParallelogram.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    protected DrawParallelogram(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(DrawParallelogram.methodSignature, DrawParallelogram.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public DrawParallelogram(long n, SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(n, DrawParallelogram.methodSignature, DrawParallelogram.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public native void DrawParallelogram(SunGraphics2D p0, SurfaceData p1, double p2, double p3, double p4, double p5, double p6, double p7, double p8, double p9);
    
    @Override
    public GraphicsPrimitive makePrimitive(SurfaceType obj, CompositeType obj2, SurfaceType surfaceType) {
        throw new InternalError("DrawParallelogram not implemented for " + obj + " with " + obj2);
    }
    
    @Override
    public GraphicsPrimitive traceWrap() {
        return new DrawParallelogram.TraceDrawParallelogram(this);
    }
    
    static {
        methodSignature = "DrawParallelogram(...)".toString();
        primTypeID = GraphicsPrimitive.makePrimTypeID();
    }
    
    private static class TraceDrawParallelogram extends DrawParallelogram
    {
        DrawParallelogram target;
        
        public TraceDrawParallelogram(DrawParallelogram target) {
            super(target.getSourceType(), target.getCompositeType(), target.getDestType());
            this.target = target;
        }
        
        @Override
        public GraphicsPrimitive traceWrap() {
            return this;
        }
        
        @Override
        public void DrawParallelogram(SunGraphics2D sunGraphics2D, SurfaceData surfaceData, double n, double n2, double n3, double n4, double n5, double n6, double n7, double n8) {
            GraphicsPrimitive.tracePrimitive(this.target);
            this.target.DrawParallelogram(sunGraphics2D, surfaceData, n, n2, n3, n4, n5, n6, n7, n8);
        }
    }
}
